﻿# SDK Pullenti Unitext, version 4.22, february 2024. Copyright (c) 2013, Pullenti. All rights reserved.
# Non-Commercial Freeware and Commercial Software.
# This class is generated using the converter UniSharping (www.unisharping.ru) from Pullenti C# project.
# The latest version of the code is available on the site www.pullenti.ru

from pullenti.unisharp.Streams import Stream

from pullenti.util.MiscHelper import MiscHelper
from pullenti.unitext.internal.pdf.PdfObject import PdfObject

class PdfStringValue(PdfObject):
    
    def __init__(self) -> None:
        super().__init__()
        self.is_hex = False
        self.val = None;
    
    def to_string_ex(self, lev : int) -> str:
        str0_ = PdfStringValue.get_string_by_bytes(self.val)
        if (len(str0_) > 100): 
            str0_ = (str0_[0:0+100] + "...")
        return "\"{0}\"".format(str0_)
    
    def is_simple(self, lev : int) -> bool:
        return True
    
    @staticmethod
    def get_string_by_bytes(buf : bytearray) -> str:
        if (buf is None): 
            return None
        if (len(buf) > 2 and buf[0] == (0xFF) and buf[1] == (0xFE)): 
            return MiscHelper.decode_string_unicode(buf, 2, len(buf) - 2)
        if (len(buf) > 2 and buf[0] == (0xFE) and buf[1] == (0xFF)): 
            return MiscHelper.decode_string_unicodebe(buf, 2, len(buf) - 2)
        return MiscHelper.decode_string_ascii(buf, 0, -1)
    
    def write0_(self, s : Stream) -> None:
        if (self.is_hex): 
            s.writebyte(ord('<'))
            i = 0
            while i < len(self.val): 
                v = (((self.val[i]) >> 4)) & 0xF
                b = (((ord('0')) + v) if v < 10 else (((ord('A')) + v) - 10))
                s.writebyte(b)
                v = ((self.val[i]) & 0xF)
                b = (((ord('0')) + v) if v < 10 else (((ord('A')) + v) - 10))
                s.writebyte(b)
                i += 1
            s.writebyte(ord('>'))
        else: 
            s.writebyte(ord('('))
            s.write(self.val, 0, len(self.val))
            s.writebyte(ord(')'))
    
    @staticmethod
    def _new233(_arg1 : bool) -> 'PdfStringValue':
        res = PdfStringValue()
        res.is_hex = _arg1
        return res